local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

--local DisplacedEnergyDebuff = GetSpellInfo(142913)
do
	local data = {
		version = 2,
		key = "Malkorok",
		zone = L.zone["Siege of Orgrimmar"],
		category = L.zone["Siege of Orgrimmar"],
		name = L.npc_SiegeOfOrgrimmar["Malkorok"],
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-MALKOROK.BLP:35:35",
		triggers = {
			scan = {71454}, 
		},
		onactivate = {
			tracing = {71454},
			tracerstart = true,
			combatstop = true,
			defeat = {71454},
			unittracing = {"boss1"},
		},
		enrage = {
			time10n = 360,
			time25n = 360,
			time10h = 360,
			time25h = 360,
			time25lfr = 720,
			timeflex = 360,
		},
		windows = {
			proxwindow = true,
			proxrange = 5,
		},
		raidicons = {
			DisplacedEnergymark = {
				varname = SN[142913],
				type = "MULTIFRIENDLY",
				persist = 60,
				unit = "#5#",
				icon = 1,
				total = 7,
				reset = 1,
				ability = 8130,
				icon2 = ST[142913],
			},
		},
		announces = { 
			DisplacedEnergysay = {
				varname = format(L.alert["%s %s %s!"],SN[142913],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[142913],L.alert["on"],L.alert["Me"]),
				ability = 8132,
				icon = ST[142913],
			},		
		},
		timers = {
			timerDisplacedEnergy = {
				{
					"message","mDisplacedEnergy",
				},
			},
			timerArcingSmash = {
				{
					"message","mArcingSmashIncoming",
				},
			},
		},
		userdata = {
			DisplacedEnergyunists = {type = "container", wipein = 3},
			DisplacedEnergyunists2 = {type = "container"},
			DisplacedEnergyCount = 0,
			BreathCount = 0,
			SeismicSlamCount = 0,
		},
		onstart = {
			{
				"alert",{"ArcingSmashcd", time = 2},
				"alert",{"SeismicSlamcd", time = 2},
				"alert",{"BloodRagecd", time = 2},
				"alert","BreathofYShaarjcd",
			},
		},
		messages = {
			mDisplacedEnergy = {
				varname = format(L.alert["%s %s %s"],SN[142913],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s %s"],SN[142913],L.alert["on"],"&list|DisplacedEnergyunists&"),
				color1 = "BROWN",
				icon = ST[142913],
				sound = "ALERT13",
			},
			mBloodRageOver = {
				varname = format(L.alert["%s %s"],SN[142879],L.alert["over"]),
				type = "message",
				text = format(L.alert["%s %s"],SN[142879],L.alert["over"]),
				color1 = "GREEN",
				icon = ST[142879],
				sound = "ALERT13",
			},
			mBreathofYShaarj = {
				varname = format(L.alert["%s (2)"],SN[142842]),
				type = "message",
				text = format(L.alert["%s (<BreathCount>)"],SN[142842]),
				color1 = "GREEN",
				icon = ST[142842],
				sound = "ALERT13",
			},	
			mSeismicSlam = {
				varname = format(L.alert["%s (2)"],SN[142851]),
				type = "message",
				text = format(L.alert["%s (<SeismicSlamCount>)"],SN[142851]),
				color1 = "GREEN",
				icon = ST[142851],
				sound = "ALERT13",
			},	
			mArcingSmash = {
				varname = format(L.alert["%s"],SN[142826]),
				type = "message",
				text = format(L.alert["%s"],SN[142826]),
				color1 = "GREEN",
				icon = ST[142826],
				sound = "ALERT13",
				counter = true,
			},
			mArcingSmashIncoming = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[142826]),
				type = "message",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[142826]),
				color1 = "RED",
				icon = ST[142826],
				sound = "ALERT13",
				counter = true,
			},
			mFatalStrike = {
				varname = format(L.alert["%s: %s 2 %s"],SN[142990],L.alert["already at"],L.alert["Stacks"]),
				type = "message",
				text = format(L.alert["%s: %s #11# %s!"],SN[142990],L.alert["already at"],L.alert["Stacks"]),
				color1 = "ORANGE",
				icon = ST[142990],
				sound = "ALERT13",
				exdps = true,
				throttle = 3,
			},
		},
		alerts = {
			-- Might of the Kor'kron
			ArcingSmashcd = {
				varname = format(L.alert["%s Cooldown"],SN[142815]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[142815]),
				time = 17.5,
				time2 = 12,
				color1 = "NEWBLUE",
				icon = ST[142815],
				ability = 8132,
			},
			SeismicSlamcd = {
				varname = format(L.alert["%s Cooldown"],SN[142851]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[142851]),
				time = 17.5,
				time2 = 5,
				color1 = "NEWBLUE",
				icon = ST[142851],
				ability = 8132,
			},
			BreathofYShaarjcd = {
				varname = format(L.alert["%s Cooldown"],SN[142842]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[142842]),
				time = 59,
				color1 = "NEWBLUE",
				icon = ST[142842],
				ability = 8132,
			},
			------
			DisplacedEnergycd = {
				varname = format(L.alert["%s Cooldown"],SN[142913]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[142913]),
				time = 10,
				color1 = "NEWBLUE",
				icon = ST[142913],
				ability = 8132,
			},
			BloodRagecd = {
				varname = format(L.alert["%s Cooldown"],SN[142879]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[142879]),
				time = 124.7,
				time2 = 122,
				color1 = "NEWBLUE",
				icon = ST[142879],
				ability = 8132,
			},		
			-- Warning
			wBloodRage = {
				varname = format(L.alert["%s %s"],L.alert["Incoming"],SN[142879]),
				type = "simple",
				text = format(L.alert["%s %s"],L.alert["Incoming"],SN[142879]),
				time = 2,
				color1 = "RED",
				icon = ST[142879],
				sound = "ALERT14",
				ability = 8132,
			},
			-- Inform
			iDisplacedEnergyself = {
				varname = format(L.alert["%s %s %s!"],SN[142913],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[142913],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[142913],
				sound = "ALERT10",
				ability = 8132,
				flashscreen = true,
			},
			iFatalStrike = {
				varname =  format(L.alert["%s - %s!"],SN[142990],L.alert["Removed"]),
				type = "inform",
				text = format(L.alert["%s - %s!"],SN[142990],L.alert["Removed"]),
				time = 2,
				color1 = "INDIGO",
				sound = "ALERT10",
				icon = ST[142990],
				exdps = true,
				ability = 8132,
				exhealer = true,
				exdps = true,
			},
			iFatalStrikeself = {
				varname = format(L.alert["%s: %s 12 %s!"],SN[136903],L.alert["already at"],L.alert["Stacks"]),
				type = "inform",
				text = format(L.alert["%s: %s #11# %s!"],SN[136903],L.alert["already at"],L.alert["Stacks"]),
				time = 2,
				color1 = "RED",
				sound = "ALERT14",
				icon = ST[136521],
				ability = 8132,
				flashscreen = true,
				exdps = true,
				exhealer = true,
				throttle = 3,
			},			
			-- Cast
			ArcingSmashCast = {
				varname = format(L.alert["%s %s"],SN[142826],L.alert["Incoming"]),
				type = "centerpopup",
				text = format(L.alert["%s %s"],SN[142826],L.alert["Incoming"]),
				time = 6,
				color1 = "NEWBLUE",
				icon = ST[142826],
				ability = 8132,
			},	
			-- Debuff
			FatalStrikeDebuff = {
				varname = format(L.alert["%s Debuff"],SN[142990]),
				type = "debuff",
				text = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[142990]),
				text2 = format(L.alert["#5# (#11#): %s"],SN[142990]),
				time = 30,
				color1 = "PURPLE",
				ability = 8130,
				icon = ST[142990],
				tag = "#5#",
				exdps = true,
			},					
		},
		events = {
			-- Displaced Energy
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {142913},
				execute = {
					{
						"expect",{"&unitisplayer|#5#&","==","true"},
						"invoke",{				
							{
								"set",{DisplacedEnergyCount = "INCR|1"},
								"insert",{"DisplacedEnergyunists","#5#"},
								--"tabinsert",{"DisplacedEnergyunists2","#5#","true"},
							--	"sinsert",{"DisplacedEnergyunists2","#5#"},
								"canceltimer","timerDisplacedEnergy",
								"scheduletimer",{"timerDisplacedEnergy",0.3},
								"raidicon","DisplacedEnergymark",
							},
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","iDisplacedEnergyself",
								"announce","DisplacedEnergysay",
								"openwindow",{"8"},
							},
							--{
							--	"expect",{"#4#","~=","&playerguid&"},
							--	"alert",{"CutterLaserCast", text = 2},
							--},
						},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {142913},
				execute = {
					{
						"set",{DisplacedEnergyCount = "DECR|1"},
						"removeraidicon","#5#",
					},
					{
						"expect",{"<DisplacedEnergyCount>","==","0"},
						"closewindow",
					},					
					{
						"expect",{"<DisplacedEnergyCount>",">","0"},
						"set",{DisplacedEnergyunists2 = "&RaidDebuff|"..SN[142913].."&"},
						"openwindow",{"8","<DisplacedEnergyunists2>"},
						--"openwindow",{"8","&RaidDebuff|"..DisplacedEnergyDebuff.."&"},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {142913},
				execute = {
					{
						"alert","DisplacedEnergycd",
					},
				},
			},
			--BloodRage
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {142879},
				execute = {
					{
						"alert","wBloodRage",
						"closewindow",
					},
				},
			},
			-- ExpelMiasma (end of blood rage)
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {143199},
				execute = {
					{
						"message","mBloodRageOver",
						"openwindow",{"5"},
						"quash","DisplacedEnergycd",
						"set",{BreathCount = 0},
						"alert",{"ArcingSmashcd", time = 2},
						"alert",{"SeismicSlamcd", time = 2},
						"batchalert",{"BreathofYShaarjcd","BloodRagecd"},
					},
				},
			},
			--BreathofYShaarj
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {142842},
				execute = {
					{
						"set",{BreathCount = "INCR|1"},
						"message","mBreathofYShaarj",
					},
					{
						"expect",{"<BreathCount>","==","1"},
						"alert",{"ArcingSmashcd", time = 2},
						"alert",{"SeismicSlamcd", time = 2},
						"alert","BreathofYShaarjcd",						
					},
				},
			},
			-- SeismicSlam
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {142851},
				execute = {
					{
						"set",{SeismicSlamCount = "INCR|1"},
						"message","mSeismicSlam",
					},
					{
						"expect",{"<SeismicSlamCount>","<","3"},
						"alert","SeismicSlamcd",
					},
				},
			},
			-- ArcingSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {142826},
				execute = {
					{
						"message","mArcingSmash",
						"scheduletimer",{"timerArcingSmash",3},
						"alert","ArcingSmashCast",
					},
				},
			},
			-- Fatal Strike
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {142990},
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","FatalStrikeDebuff",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"FatalStrikeDebuff", text = 2},
					},
					{
						"expect",{"#11#",">=","12"},
						"message","mFatalStrike",
						"invoke",{
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","iFatalStrikeself",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"expect",{"&unitisdead|player&","==","0"},
								"expect",{"&playerdebuff|"..SN[142990].."&","==","false"},
								"alert","iFatalStrike",	
							},							
						},
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end
